﻿Imports System.Data
Imports Infragistics.UltraChart.Shared.Styles
Imports Infragistics.UltraChart.Resources.Appearance
Imports Infragistics.UltraChart.Core.Layers
Imports Infragistics.WebUI.UltraWebChart
Imports System.Drawing
Imports Infragistics.UltraChart.Core.Primitives
Imports Infragistics.UltraChart.Data.Series

Partial Class _Default
    Inherits System.Web.UI.Page

    ''' <summary>
    ''' Page_Load - Create Numeric Series, assign DataTable 
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load

        ' Create DataTable & Add Rows
        Dim DataTable1 As New DataTable
        DataTable1.Columns.Add("Label", GetType(String))
        DataTable1.Columns.Add("Amount", GetType(Double))

        DataTable1.Rows.Add(New [Object]() {"Google", 1000000})
        DataTable1.Rows.Add(New [Object]() {"Yahoo", 500000})
        DataTable1.Rows.Add(New [Object]() {String.Empty, 0})

        ' Create a NumericSeries and Bind DataTable
        Dim series As NumericSeries = New NumericSeries()
        series.Data.DataSource = DataTable1
        series.Data.LabelColumn = "Label"
        series.Data.ValueColumn = "Amount"
        series.DataBind()

        ' Add NumericSeries to UltraChart 
        UltraChart1.Series.Add(series)

        ' Set up ChartTextAppearance
        Dim cText As Infragistics.UltraChart.Resources.Appearance.ChartTextAppearance = _
            New Infragistics.UltraChart.Resources.Appearance.ChartTextAppearance()

        ' Change ItemFormatString to "<DATA_VALUE:#>" so it will 
        ' show only significant digits and zeroes will be blank
        'cText.ItemFormatString = "<DATA_VALUE:#,0>"
        cText.ItemFormatString = "<DATA_VALUE:#>"

        cText.Visible = True
        cText.Column = -2
        cText.Row = -2

        UltraChart1.ColumnChart.ColumnSpacing = 1

        ' Set up WebChart Legend
        UltraChart1.Legend.Location = LegendLocation.Top
        UltraChart1.Legend.Visible = True

    End Sub

    ''' <summary>
    ''' FillSCeneGraph - Set DataValue Font and Orientation to align 
    '''      and center the Values in Columns of Chart Text
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Protected Sub UltraChart1_FillSceneGraph(ByVal sender As Object, ByVal e As Infragistics.UltraChart.Shared.Events.FillSceneGraphEventArgs) Handles UltraChart1.FillSceneGraph

        ' Create PrimitiveCollection Array
        Dim primitivesToAdd As New PrimitiveCollection()
        ' Loop through Primitive in WebChart
        For Each currentPrimitive As Primitive In e.SceneGraph
            ' Create Box Object
            Dim b As Box = TryCast(currentPrimitive, Box)
            ' Check if Box and if TypeOf ColumnLayer
            If b IsNot Nothing AndAlso TypeOf b.Layer Is ColumnLayer Then
                '  Create LabelStyle Object
                Dim l As New LabelStyle()
                ' Set Label TextOrientation to VerticalLeftFacing
                l.Orientation = TextOrientation.VerticalLeftFacing
                ' Create Text Object, Add Label Style
                Dim t As New Text(b.rect, b.Value.ToString(), l)
                ' Set Text Font and Alignment
                t.labelStyle.Font = New System.Drawing.Font("Verdana", 14, FontStyle.Bold)
                t.labelStyle.HorizontalAlign = StringAlignment.Center
                ' Add Text to Array
                primitivesToAdd.Add(t)
            End If
        Next
        ' Add Array to WebChart
        e.SceneGraph.AddRange(primitivesToAdd.ToArray())

    End Sub

End Class
